#! /usr/bin/env python

import socket
import sys
import time
import string
import os

def traite_requete (connexion):
    BUFSIZE=512
    connexion.send ("Premier argument ?\n")
    buf = connexion.recv (BUFSIZE)
    a = string.atol(buf)
    connexion.send ("Deuxime argument ?\n")
    buf = connexion.recv (BUFSIZE)
    b = string.atol(buf)
    res = "Rsultat : %d + %d = %d\n" % (a, b, a + b)
    connexion.send (res)
    connexion.close ()
    
def main ():
    s = socket.socket (socket.AF_INET, socket.SOCK_STREAM)
    host = "localhost"
    port = int(sys.argv[1])
    print "Listening from %s:%d" % (host, port)
    s.bind ((host, port))
    s.listen (5)
    while 1:
        (connexion, (client, p)) = s.accept ()
        print "Handling connection from %s:%s" % (client, p)
        pid = os.fork ()
        if pid == 0:
            # On est dans le fils
            s.close ()
            traite_requete (connexion)
            sys.exit (0)
        else:
            # On est dans le pre
            connexion.close ()

if __name__ == "__main__":
    if len(sys.argv) < 2:
        print "Syntaxe : %s port" % sys.argv[0]
        sys.exit (1)
    main ()
